% Skript normalfit.m
%
% Autor: Winfried Koller
% Datum: 22. Juni 2001

close all
clear all

M=50;

N=input (' Geben Sie die Zahl der Zufallszahlen ein : ');
if isempty(N), N=1000;end;
N=floor(N);


if N<50, N=50; end
if N>1e+6, N=1e+6; end

u=rand(N,2);
v=2*u-1;

v(:,3) = v(:,1).*v(:,1) + v(:,2).*v(:,2);
v(:,4) = sqrt(-2.0*log(v(:,3))./v(:,3));

l=v(:,3)<=1.0;

disp ([' Prozentsatz der Punkte mit r<1 : ',num2str(100*sum(l)/N)]);

m=v(l,:);

x=m(:,1).*m(:,4);
y=m(:,2).*m(:,4);

p=inline('b(1)*exp(-b(2)*(x-b(3)).^2)','b','x')

A=max(x);
alpha=1;
x0=0.2;

[hx,x1] = hist(x,M);
[hy,y1] = hist(x,M);
b0=[A,alpha,x0];
bx=nlinfit(x1,hx,p,b0);
by=nlinfit(y1,hy,p,b0);
xx=linspace(-4,4);
x1=p(bx,xx);
y1=p(by,xx);

figure
subplot(3,1,1)
hist(v(:,3),M)
subplot(3,1,2)
hold on
hist (x,M)
plot (xx,x1,'y','LineWidth',4);
hold off
axis([-4 4 0 inf])
subplot (3,1,3)
hold on
hist (y,M)
plot (xx,y1,'y','LineWidth',4);
hold off
axis([-4 4 0 inf])
