function out = dinput(outtext,str,def,ran)
% Inputroutine mit Defaultwert und Bereichsberprfung
%
% Input:  NICHT ALLE NOTWENDIG
%         outtext  String mit Ausgabetext
%         str      's', wenn string als Eingabe erwartet wird
%                  [] oder String,der nicht mit s beginnt, wenn Zahl erwartet wird
%         def      Defaultwert bei leerer Eingabe
%         ran      Mgliche Werte oder Bereich
%                   Array von Zahlen oder Zelle von Strings
%                    [1 2 3 4 5]   - Fixe Zahlen
%                    [1:20]        - Vektor
%                    {'a' 'b' 'c'} - Strings
%                   Logischer Ausdruck (formuliert mit x)
%                    'x > 0 & x < 5' - Bereich
%
% Autor: Winfried Kernbichler      23.01.2000

% berprfung von outtext und str
if nargin == 0, outtext = 'Eingabe der Variablen: '; end
if nargin >= 1, if ~ischar(outtext), error('1. Variable: Kein String'); end, end

% Logische Variable: logstr 
%  0: Input soll kein String sein
%  1: Input soll String sein 
logstr = 0;
if nargin >= 2,
   if ischar(str), if strcmp(lower(str(1)),'s'), logstr = 1; end
   else, if ~isempty(str),	error('2. Variable: Kein String'); end
   end
end

% Logische Variable: logdef 
%  0: Kein Defaultwert definiert
%  1: Defaultwert definiert
logdef = 0;
if nargin >= 3 & ~isempty(def),
   logdef = 1;
   if ischar(def), outtext = [outtext,' [',def,'] ']; logstr  = 1;
   else, outtext = [outtext,' [',num2str(def),'] '];
   end
end

% Logische Variable: logran 
%  0: kein Range definiert
%  1: Range durch Liste oder Zelle definiert
%  2: Range durch String mit logischer Abfrage definiert (eval)
logran = 0;
if nargin >= 4 & ~isempty(ran), 
   if ~ischar(ran), logran = 1; else, logran = 2; end 
end

% Input
cont = 1;
while cont           % Solange bis es richtig ist (cont ~= 0)
   if cont == 2,     % Ausgabe des Bereichs, falsch es einmal falsch war
      disp('   Zulssiger Bereich:');
      if logran==1, disp(ran);           end        % Zahlenwerte
      if logran==2, disp(['     ',ran]); end        % String mit logischem Ausdruck
   end
   cont = cont + 1;
   % Abfrage
   if logstr, out = input(outtext,'s'); else out = input(outtext); end
   % Defaultwert
   if logdef & isempty(out), out = def; end
   % berprfung des Wertebereichs
   switch logran                                    % cont=0 beendet Schleife
      case 0, cont = 0;                             % Kein Bereich definiert
      case 1, if ismember(out,ran), cont = 0; end   % Teil einer Menge oder Liste
      case 2, x = out; if eval(ran), cont = 0; end  % Logisch richtiger Ausdruck
   end
end