function [x,y,z] = func2d2(xi,yi)
% Die Funktion func2d2 berechnet z(x,y) = x.^2 + y.^2 
% Inputparameter werden berprft.
% Input:  Vektoren xi und yi
% Output: x, y, Funktion z(x,y)
%         Fehlervariable ERR - global

% Autor:  Winfried Kernbichler
% Datum:  5.11.1999

global ERR; % Globale Fehlervariable

% berprfung der Anzahl der Inputparameter
% Die Variable nargin gibt die Anzahl der Inputparameter an.
if (nargin == 0), 
   x = -1:0.1:1;
else
   x = xi;
end
% Kann auch kompakt geschrieben werden. 
if (nargin <= 1), y = -1:0.1:1; else y = yi; end

% Fehlerberprfung
err = 0;
% berprfung, ob reelle Zahlen bergeben werden.
if ( ~isnumeric(x) | ~isreal(x) ), err=1; end
if ( ~isnumeric(y) | ~isreal(y) ), err=2; end
% berprfung der Inputparameter ob sie Vektoren und 
% keine Matrizen oder Skalare sind.
if ( min(size(x)) ~= 1 | length(x) == 1 ), err=3; end
if ( min(size(y)) ~= 1 | length(y) == 1 ), err=4; end
% berprfung, ob x und y monoton steigend sind.
if ( ~err),
   if ( min(diff(x)) <= 0 | min(diff(y)) <= 0 ), err=5; end
end
ERR = err; % Zuweisung auf globale Variable ERR

% Rechnung nur, wenn es keinen Fehler gibt.
if ( ~err )
	[xx,yy] = meshgrid(x,y); % Netzgitter in Form zweier Matrizen
	z = xx.^2 + yy.^2; % Ausrechnen der Funktion (Punkt Notation)
else
   z = []; % Variable existiert, ist aber leer.
end

