% Script fr Funktionsdarstellung.
% Diskussion von variablen Inputlngen und Defaultwerten.
% Diskussion von Inputberprfung.
%
% Bentigt die Funktionen func2d1, func2d2, func2d3, func2d und
% die Funktionen myplot1 und myplot2.
%
% Autor: Winfried Kernbichler, 7.11.1999

echo off;
clc; % Lscht bestehende Anzeige im Commandwindow

fprintf(1,'\tScript fr Funktionsdarstellung. \n')
fprintf(1,'\tDiskussion von variablen Inputlngen und Defaultwerten. \n\n')
fprintf(1,'\tDiskussion von Inputberprfung. \n\n')
fprintf(1,'\t\tAutor: Winfried Kernbichler, 7.11.1999 \n\n')
% Hier ist der File Identifier FID=1 : Ausgabe am Schirm

% Definition der Inputvektoren
x = -2:0.1:2;
y = -2:0.1:2;

% Aufruf der Funktion
fprintf(1,'Aufruf der Funktion und graphische Darstellung. \n')
z1 = func2d1(x,y); 
fprintf(1,'Die Dimension der Matrix z1 ist: \n')
fprintf(1,'  z: %2.0f  %2.0f \n\n',size(z1));
% ffnen eines Fensters fr die graphische Darstellung
fig1=figure(1);
colormap('default');
p1 = myplot1(x,y,z1);

fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause
% Die Funktion wurde nun so modifiziert, da sie mit weniger
% Inputvariablen auskommt und dafr Defaultwerte nimmt.
[x2,y2,z2] = func2d2;
[x3,y3,z3] = func2d2(x);
[x4,y4,z4] = func2d2(x,y);

clf; % Clears Figure
subplot(2,2,1);
p1 = myplot1(x,y,z1);
title('Original')
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

subplot(2,2,2);
p2 = myplot1(x2,y2,z2);
title('Default x und y')
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

subplot(2,2,3);
p3 = myplot1(x3,y3,z3);
title('Default y')
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

subplot(2,2,4);
p4 = myplot1(x4,y4,z4);
title('Neues Original')
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% Auerdem wurde die Funktion so modifiziert, da auch falsche Inputgren
% bermittelt werden knnen, ohne da es zu einem Programmabsturz kommt.
% Beispiele:
% Fehlervariable: ERR
global ERR % mu auf beiden Seiten definiert sein.
func2d2('t');                       % String
fprintf(1,'ERR: \t%1.0f \n',ERR);
func2d2([1 2;3 4]);                 % Matrix statt Vektor
fprintf(1,'ERR: \t%1.0f \n',ERR);
func2d2(1,2);                       % Skalar
fprintf(1,'ERR: \t%1.0f \n',ERR);
func2d2([1 2 4 3 5]);               % Input nicht monoton
fprintf(1,'ERR: \t%1.0f \n\n',ERR);
clear global ERR % Globale Variable wieder lschen
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

fig1; clf;
% Weiterentwicklung der Funktion
% z(x,y) = a*x^2 + b*x*y + c*y^2 + d*x + e*y + f 
[x1,y1,z1] = func2d3;
subplot(2,2,1);
p5 = myplot1(x1,y1,z1);
title('x^2 + x*y + y^2');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

x = -1:0.1:1; y = -1:0.1:1;
[x1,y1,z2] = func2d3(x,y,1,1,1);
subplot(2,2,2);
p6 = myplot1(x1,y1,z2);
title('Gleich wie Default');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

[x1,y1,z2] = func2d3(x,y,1,1,1,1);
subplot(2,2,2);
p6 = myplot1(x1,y1,z2);
title('x^2 + x*y + y^2 + x');

[x1,y1,z3] = func2d3(x,y,1,1,1,1,1);
subplot(2,2,3);
p6 = myplot1(x1,y1,z3);
title('x^2 + x*y + y^2 + x + y');

[x1,y1,z4] = func2d3(x,y,1,1,1,1,1,1);
subplot(2,2,4);
p6 = myplot1(x1,y1,z4);
title('x^2 + x*y + y^2 + x + y + 1');

fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause
fprintf(1,'Verschiedene Plotversionen. \n\n');
fig1; clf;
clf;

% Darstellung von Funktionen
x = -2:0.1:2;
y = -2:0.1:2;
[x1,y1,z5] = func2d3(x,y,1,-1,1,1,-1,3);
p7 = myplot2(x1,y1,z5,'question');
[x1,y1,z5] = func2d3(x,y,1,-1,-2,1,-1,1);
p7 = myplot2(x1,y1,z5,'surf');title('surf');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% Andere Mglichkeiten
[x1,y1,z5] = func2d3(x,y,1,-2,-1,1,-1,3);
p7 = myplot2(x1,y1,z5,'surfng');title('surf ohne Linien');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause
[x1,y1,z5] = func2d3(x,y,1,-0.5,-2,0,0,3);
p7 = myplot2(x1,y1,z5,'surfc');title('surfc');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause
[x1,y1,z5] = func2d3(x,y,-1,0.5,-2,0,0,1);
p7 = myplot2(x1,y1,z5,'surfl');title('surfl');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause
[x1,y1,z5] = func2d3(x,y,-1,0.5,-2,0,0,1);
p7 = myplot2(x1,y1,z5,'density');title('density');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause
[x1,y1,z5] = func2d3(x,y,-1,0.5,2,1,1,1);
p7 = myplot2(x1,y1,z5,'densityint');title('densityint');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause
[x1,y1,z5] = func2d3(x,y,-1,1,3,1,1,0);
p7 = myplot2(x1,y1,z5,'mesh');title('mesh');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause
[x1,y1,z5] = func2d3(x,y,-1,0,1,0,0,0);
p7 = myplot2(x1,y1,z5,'meshc');title('meshc');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause
[x1,y1,z5] = func2d3(x,y,-1,1,0,1,1,0);
p7 = myplot2(x1,y1,z5,'meshz');title('meshz');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause
[x1,y1,z5] = func2d3(x,y,1,0,-1,0,0,0);
p7 = myplot2(x1,y1,z5,'waterfall');title('waterfall');
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% Komfortable Form auch fr hhere Potenzen
x = -1:0.02:1;
y = -1:0.02:1;
for n = 0:10,
	nv = (n+1)*(n+2)/2;
	a = ones(1,nv); a(nv)=-1;
	[x1,y1,z6] = func2d(n,x,y,a);
   p7 = myplot2(x1,y1,z6,'mesh');
   title( strcat( 'n=', num2str(n) ) );
   pause(3);
end

fprintf(1,'Zur Beendung des Scripts eine Taste drcken. \n\n');pause
% Schlieen der Figuren
close(fig1);
% Lschen der Variablen
clear a nv p5 x2 y2 z3        
clear p1 p6 x3 y3 z4        
clear fig1 p2 p7 x4 y4 z5        
clear p3 x y z1 z6        
clear n p4 x1 y1 z2
fprintf(1,'Danke. \n\n');pause

