function varargout = htslider(flag,val)

global figure_1
global axes_1
global axes_2
global slider_1
global slider_1_text_1a 
global slider_1_text_1b 
global slider_1_text_1c
global slider_1_text_1d
global slider_2
global slider_2_text_1a 
global slider_2_text_1b 
global slider_2_text_1c
global slider_2_text_1d
global line_2a
global line_2b

global xval yval
global xlim ylim

global textshift
global fontunits fontsize

if nargin == 0
  flag = 'init';
end

switch flag
  case 'init'
    textshift = 0.045;
    fontunits = 'normalized';
    fontsize  = 0.03;
    
    htslider('init_figure_1');
    htslider('init_axes_1');
    htslider('init_slider_1');
    htslider('init_slider_2');
    htslider('init_axes_2');
    htslider('init_line_2');
  case 'init_figure_1'
    figure_1 = figure(1);clf
    set(figure_1,...
	'Units','normalized' ...
	);
  case 'init_axes_1'
    axes_1 = axes( ...
	'Parent',figure_1, ...
	'Units','normalized', ...
	'Position',[0 0 1 1], ...
	'Visible','off' ...
	);
  case 'init_axes_2'
    xlim = [get(slider_1,'Min'),get(slider_1,'Max')];
    ylim = [get(slider_2,'Min'),get(slider_2,'Max')];
    axes_2 = axes(...
	'Parent',figure_1, ...
	'Units','normalized', ...
	'Position',[0.1 0.3 0.8 0.6], ...
	'XLim',xlim, ...
	'YLim',ylim, ...
	'Box','on', ...
	'Visible','on' ...
	);                  
    xlabel('x');
    ylabel('y');           
  case 'init_line_2'
    xlim = [get(slider_1,'Min'),get(slider_1,'Max')];
    ylim = [get(slider_2,'Min'),get(slider_2,'Max')];
    line_2a = line( ...
	'Parent',axes_2, ...
	'ButtonDownFcn','htslider hit_line_2a',	...
	'EraseMode','background', ...
	'Color','blue',	...
	'XData',[xval xval], ...
	'YData',ylim ...
	);
    line_2b = line( ...
       'Parent',axes_2,	...
       'ButtonDownFcn','htslider hit_line_2b', ...
       'EraseMode','background', ...
       'Color','blue', ...
       'XData',xlim, ...
       'YData',[yval yval] ...
       );
 case 'init_slider_1'               
   position   = [0.1 0.1 0.35 0.03];
   smin       = 0;
   smax       = 20;
   xval       = 10;
   sliderstep = [0.05 0.1];
   slider_1 = uicontrol( ...
       'Parent',figure_1, ...
       'Style','slider', ...
       'String','Clear', ...
       'Min',smin, ...
       'Max',smax, ...
       'Value',xval, ...
       'SliderStep',sliderstep, ...
       'Units','normalized', ...
       'Position',position, ...
       'ToolTipString','Slider for x', ...
       'Visible','on', ...
       'Callback','htslider slider_1' ...
       ); 
   htslider('init_slider_1_text_1');
 case 'init_slider_2'               
   position   = [0.55 0.1 0.35 0.03];
   smin       = 0;
   smax       = 40;
   yval       = 30;
   sliderstep = [0.05 0.1];
   slider_2 = uicontrol( ...
       'Parent',figure_1, ...
       'Style','slider', ...
       'String','Clear', ...
       'Min',smin, ...
       'Max',smax, ...
       'Value',yval, ...
       'SliderStep',sliderstep, ...
       'Units','normalized', ...
       'Position',position, ...
       'ToolTipString','Slider for y', 	...
       'Visible','on', 	...
       'Callback','htslider slider_2' ...
       ); 
   htslider('init_slider_2_text_1');   
 case 'init_slider_1_text_1'
   position = get(slider_1,'Position');
   smin     = get(slider_1,'Min');
   smax     = get(slider_1,'Max');
   
   textpos  = [position(1),position(2)+position(4)/2+textshift];
   slider_1_text_1a = text( ...
       'Position',textpos, ...
       'Parent',axes_1, ...
       'FontUnits',fontunits, ...
       'FontSize',fontsize, ...
       'HorizontalAlignment','center', ...
       'VerticalAlignment','middle', ...
       'String',num2str(smin) ...
       );
                       
   textpos  = [position(1)+position(3),position(2)+position(4)/2+textshift];                  
   slider_1_text_1b = text( ...
       'Position',textpos, ...
       'Parent',axes_1, ...
       'FontUnits',fontunits, ...
       'FontSize',fontsize, ...
       'HorizontalAlignment','center', 	...
       'VerticalAlignment','middle', ...
       'String',num2str(smax) ...
       );
                       
   textpos  = [position(1)+position(3)/2,position(2)+position(4)/2+textshift];                  
   slider_1_text_1c = text( ...
       'Position',textpos, ...
       'Parent',axes_1,	...
       'FontUnits',fontunits, ...
       'FontSize',fontsize, ...
       'HorizontalAlignment','center', ...
       'VerticalAlignment','middle', ...
       'String',num2str(xval) ...
       );
                       
   textpos  = [position(1)+position(3)/2,position(2)+position(4)/2-textshift];                  
   slider_1_text_1d = text( ...
       'Position',textpos, ...
       'Parent',axes_1, ...
       'FontUnits',fontunits, ...
       'FontSize',fontsize, ...
       'HorizontalAlignment','center', ...
       'VerticalAlignment','middle', ...
       'String','x-Slider' ...
       );                                             
 case 'init_slider_2_text_1'
   position = get(slider_2,'Position');
   smin     = get(slider_2,'Min');
   smax     = get(slider_2,'Max');
   
   textpos  = [position(1),position(2)+position(4)/2+textshift];
   slider_2_text_1a = text( ...
       'Position',textpos, ...
       'Parent',axes_1,	...
       'FontUnits',fontunits, ...
       'FontSize',fontsize, ...
       'HorizontalAlignment','center', ...
       'VerticalAlignment','middle', ...
       'String',num2str(smin) ...
       );
                       
   textpos  = [position(1)+position(3),position(2)+position(4)/2+textshift];                  
   slider_2_text_1b = text( ...
       'Position',textpos, ...
       'Parent',axes_1, ...
       'FontUnits',fontunits, ...
       'FontSize',fontsize, ...
       'HorizontalAlignment','center', ...
       'VerticalAlignment','middle', ...
       'String',num2str(smax) ...
       );
                       
   textpos  = [position(1)+position(3)/2,position(2)+position(4)/2+textshift];                  
   slider_2_text_1c = text( ...
       'Position',textpos, ...
       'Parent',axes_1, ...
       'FontUnits',fontunits, ...
       'FontSize',fontsize, ...
       'HorizontalAlignment','center', ...
       'VerticalAlignment','middle', ...
       'String',num2str(yval) ...
       );
                       
   textpos  = [position(1)+position(3)/2,position(2)+position(4)/2-textshift];                  
   slider_2_text_1d = text( ...
       'Position',textpos, ...
       'Parent',axes_1,	...
       'FontUnits',fontunits, ...
       'FontSize',fontsize, ...
       'HorizontalAlignment','center', ...
       'VerticalAlignment','middle', ...
       'String','y-Slider' ...
       );                                             
 case 'slider_1'   
   xval = get(slider_1,'Value');
   set(slider_1_text_1c,'String',num2str(xval))
   set(line_2a,'XData',[xval xval])
 case 'slider_2'       
   yval = get(slider_2,'Value');
   set(slider_2_text_1c,'String',num2str(yval))                                             
   set(line_2b,'YData',[yval yval])
 case 'hit_line_2a'
   axes(axes_2);
   set(figure_1,'WindowButtonUpFcn','htslider end_move_line_2a');
   set(figure_1,'WindowButtonMotionFcn','htslider move_line_2a');   
   set(line_2a,'Color','red')
 case 'move_line_2a'
   cp = get(axes_2,'CurrentPoint');
   xval = min([max([cp(1,1),xlim(1)]),xlim(2)]);   
   set(line_2a,'XData',[xval xval]);
   set(slider_1,'Value',xval);
   set(slider_1_text_1c,'String',num2str(xval));
 case 'end_move_line_2a'
   set(figure_1,'WindowButtonMotionFcn','');
   set(figure_1,'WindowButtonUpFcn','');
   set(line_2a,'Color','blue');
 case 'hit_line_2b'
   axes(axes_2);
   set(figure_1,'WindowButtonUpFcn','htslider end_move_line_2b');
   set(figure_1,'WindowButtonMotionFcn','htslider move_line_2b');   
   set(line_2b,'Color','red')
 case 'move_line_2b'
   cp = get(axes_2,'CurrentPoint');
   yval = min([max([cp(1,2),ylim(1)]),ylim(2)]);   
   set(line_2b,'YData',[yval yval]);
   set(slider_2,'Value',yval);
   set(slider_2_text_1c,'String',num2str(yval));
 case 'end_move_line_2b'
   set(figure_1,'WindowButtonMotionFcn','');
   set(figure_1,'WindowButtonUpFcn','');
   set(line_2b,'Color','blue');
 otherwise                       
   error(['Unknown flag ''' flag '''.']);
end

