% Stellt Kegelschnitte in Form von Contour- und Surface-Plots dar
%
% Autor: Winfried Kernbichler    09.01.2000
%
% Bentigt Exekution von kegelschnitt vor dem Aufruf

% Erzeugen eines Meshgrids aus x- und y-Vektoren 
[XX,YY] = meshgrid(x,y);

% Berechnen der Funktion
ZZ = A(1,1)*XX.^2 + 2*A(1,2)*XX.*YY + A(2,2)*YY.^2 + ...
   2*A(1,3)*XX    + 2*A(2,3)*YY     + A(3,3);

% Minimal und Maximalwerte von ZZ zur Auswahl der Konturen 
zmax = max(max(ZZ));
zmin = min(min(ZZ));
cl = [zmax/2 zmax/4 zmax/8 zmax/16 0 zmin/16 zmin/8 zmin/4 zmin/2];

% Contourplot mit Konturen an den Stellen cl
fig3 = figure(3); clf;
[ch,lh] = contour(x,y,ZZ,cl);
set(gca,'Xlim',[xmin,xmax]);
set(gca,'Ylim',[ymin,ymax]);
xlabel('x'); ylabel('y');
% Wre eine Mglichkeit die Konturen zu beschriften
% clabel(ch,lh,'FontSize',8,'LabelSpacing',500);
colorbar; % Zuordnung von Farben zu Zahlenwerten

% Plotten der Daten
hold on
plot(xd,yd,'.r')
hold off

% Surfaceplot
fig4 = figure(4); clf;
sh = surf(x,y,ZZ);
view(2); % Betrachtung von Oben
set(sh,'EdgeColor','none'); % Keine Farben der Linien
set(gca,'Xlim',[xmin,xmax]);
set(gca,'Ylim',[ymin,ymax]);
xlabel('x'); ylabel('y');
colorbar;

% Figur 3 wird aktuelle Figur
figure(3);