function legz = legzval(n,x)
% Evaluates Associated Legendre functions of order n for vector x
% m = 0:n
% Written by Winfried Kernbichler
legz = zeros(n+1,length(x));

pol = legpol(n);
for m = 0:n
   legz(m+1,:) = (1 - x.^2).^(m/2) .* polyval(pol,x);
   pol = polyder(pol);
end





