% Script zum Testen von Programmen zur Lsung quadratischer Gleichungen.
% Diskussion von globalen Variablen
%
% Bentigt die Funktionen quadgl und quadgl1
%
% Autor: Winfried Kernbichler, 14.11.1999

echo off;
clc; % Lscht bestehende Anzeige im Commandwindow

% Schreiben einer berschrift
fprintf(1,'\tScript zum Testen von Programmen zur Lsung quadratischer Gleichungen. \n')
fprintf(1,'\tDiskussion von globalen Variablen. \n')
fprintf(1,'\t\tAutor: Winfried Kernbichler, 14.11.1999 \n\n')
% Hier ist der File Identifier FID=1 : Ausgabe am Schirm

global MESSAGE ERROR WARNING % define global messages

MESSAGE = 1; % We would like to see messages printed

a = [1 0; 4 0]; % define small 2x2 test arrays
b = [1 2; 3 0];
c = ones(2);

[x1,x2] = quadgl(a,b,c); % solve equation

if ~ERROR % test the results 
   p1 = a.*x1.^2 + b.*x1 + c; p1>eps % show only true if test is 
   p2 = a.*x2.^2 + b.*x2 + c; p2>eps % larger than the small number eps (10^-16)
end

fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% Test with larger arrays
% Goal: Speed difference with different methods
n = 50;
a = rand(n); b = rand(n); c = rand(n); % (n x n)-arrays with random numbers

% Method with formula
tic; [x1a,x2a] = quadgl(a,b,c); ta=toc;
% Method with MATLAb command ROOTS and FOR-LOOP
tic; [x1b,x2b] = quadgl1(a,b,c); tb=toc;
% Ratio of execution times (method with roots) / (method with formula)

fprintf(1,'\tZeit: \tFormula \t\tRoots\n');
fprintf(1,'\tZeit: \tFormula \t\tRoots\n');
fprintf(1,'\t\t%12.8e  \t%12.8e \n',ta,tb);
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause

% Der Befehl ROOTS kann aber in anderer Hinsicht mehr:
% Findet alle Lsungen einer Gleichung vom Typ:
% a_n*x^n + ... + a_3*x^3 + a_2*x^2 + a_1*x + a_0 = 0
% Dies ist mit normalen Formeln fr n>3 nur in Spezialfllen mglich
pol = [1 3 4 5 2 1]; % Definition eines Polynoms
% Loesung der Gleichung: x^5 + 3*x^4 + 4*x^3 + 5*x^2 + 2*x + 1
% ACHTUNG NUR FR SKALARE
sol = roots(pol)
fprintf(1,'Zur Fortsetzung eine Taste drcken. \n\n');pause
clc;
% Es geht auch mit integer Lsungen
pol = [1 -2 -10 20 9 -18]
sol = roots(pol)
% Der umgekehrte Befehl is poly
pol = poly(sol)
fprintf(1,'Danke. \n\n');

