function [v,lim]=sumrez(L,imax)
% Lst Beispiel 5 und stellt es graphisch dar
% v = Summe von l=1 bis L von (1/l)^i, wobei i von 1 bis imax luft
% Fr alle Werte von i soll die jeweilige Summe in einem Zeilenvektor 
% dargetsellt werden.
% 
% Input:  L     maximales l
%         imax  maximale Potenz
% Output: v     Zeilenvektor mit Ergebnis der Summation
%         lim   Limes der unendlichen Reihe (mit zeta)
%
% Das Programm erzeugt einen Plot, der das Konvergenzverhalten zeigt. 

% Autor: Winfried Kernbichler    14.11.1999

[i2,L2] = meshgrid(1:imax,1:L);
% L2 : imax Spalten mit jeweils allen l-Werten
% i2 : L Zeilen mit jeweils allen Hochzahlen i
v1 = cumsum(L2.^(-i2)); 
% Der Befehl cumsum ist nur fr den Plot notwendig
v = v1(end,:);
% Das Problem wre auch mit v = sum(L2.^(-i2)) gelst

% Darstellung in einem Plot
p=plot(v1(:,2:end));
xlabel('l');
ylabel(['Summe fr L = ',num2str(L),'  und i_{max} = ',num2str(imax)]);
title('Konvergenzverhalten');

% Darstellung vom Konvergenzlimit
x = [0; L]; % nur zwei Werte in einer Spalte (Anfang und Ende)
lim = zeta(1:imax);
lim2 = repmat(lim(2:end),2,1); 
% Die zeta-Funktion ist die Lsung der unendlichen Reihe
hold on % Zeichnet dazu
p1 = plot(x,lim2);
hold off
