
% script 7
%
% Demo: Zwei Kurven mit verschiedenen Wertebereichen fr die x- und y-Achse
%       zeichnen und Markierungen der Achsen anpassen
%
% Autor:           Bernhard Seiwald
% Erstellt, am:    16.11.1999
% Modifiziert, am: 
%
%alle vorherigen Variablen lschen
clear all;
% Ausgabefenster lschen
clf;
% x- und y-Vektor
x1 = 0:9;
y1 = x1.^2;
x2 = -10:10;
y2 = x2.^3;
% plotten der 1. Funktion
plot(x1, y1, 'b');
% handle der aktuellen Achse
a1 = gca;

% neuen handle besorgen
a2 = axes;
% plotten der 2. Funktion
plot(x2, y2, 'r');
% Seiten fr Markierungen festlegen
set(a2, 'xaxislocation', 'top', 'yaxislocation', 'right', 'color', 'none');
% extradicke Markierungen ausschalten
set([a1 a2], 'box', 'off');
% bei beiden Achsen Grid einschalten
axes(a1);
grid on;
axes(a2);
grid on;

% Text anzeigen
disp('beliebige Taste drcken');
%auf Tastendruck warten
pause

% Anzahl der x-Markierungen der 1. Achse holen
numxticka1 = length(get(a1, 'xtick'));
% xlimits fr Achse 2 holen
xlima2 = get(a2, 'xlim');
% Inkrement fr 2. x-Achse berechnen
xincr = (abs(diff(xlima2)) / (numxticka1 - 1));
% neue Markierungen fr 2. x-Achse berechnen
newxtks = [xlima2(1) :xincr: xlima2(2)];
% neue Markierungen der 2. x-Achse zeichnen
set(a2, 'xtick', newxtks);
% Anzahl der y-Markierungen der 1. Achse holen
numyticka1 = length(get(a1, 'ytick'));
% ylimits fr Achse 2 holen
ylima2 = get(a2, 'ylim');
% Inkrement fr 2. y-Achse berechnen
yincr = (abs(diff(ylima2)) / (numyticka1 - 1));
% neue Markierungen fr 2. y-Achse berechnen
newytks = [ylima2(1) :yincr: ylima2(2)];
% neue Markierungen der 2. x-Achse zeichnen
set(a2, 'ytick', newytks);

% fr besseres Aussehen wird gerundet (ist nicht immer sinnvoll)
set(a2, 'xticklabel', round(get(a2, 'xtick')) )
set(a2, 'yticklabel', round(get(a2, 'ytick')) )

% Farben fr Gitter und Markierungen zur besseren Zuordnung setzen
%set(a1, 'XColor', 'blue', 'YColor', 'blue');
%set(a2, 'XColor', 'red', 'YColor', 'red');
