% script3
%
% Demo: Errorbars
%
% Autor:           Alexander Prll
% Erstellt, am:    28.11.1999
% Modifiziert, am: 
%
% alle vorherigen Variablen lschen
clear all;

%ffnen einer figure
fig=figure;

% x-Werte
x   = 0:10;
xpl = 0:.01:10;


% ***************************************************
% subplot 1
% ***************************************************
subplot(1,2,1)

% "Testdaten erzeugen"
y  = 1+0.5*x-.07*x.^2;
ypl= 1+0.5*xpl-.07*xpl.^2;
% Ploten der "echten" Kurve
p1=plot(xpl,ypl,'b');
axis([-1 11 -2 2.5])
grid on
xlabel('x')
ylabel('f(x)')
title('Aus dieser Kurve werden Testdaten ermittelt')

% Text anzeigen
disp('beliebige Taste drcken');
%auf Tastendruck warten
pause

% "konstanten Mefehler" der Gre err=.2 erzeugen
err= 0.2*ones(size(y));
ym = y + err.*randn(size(y));
% Ploten der "Mepunkte"
hold on
p2=errorbar(x,ym,err,'ko');
title('Das sind die Testdaten (mit konst. Fehler) ')

% Text anzeigen
disp('beliebige Taste drcken');
%auf Tastendruck warten
pause

% Daraus Kurve rekonstruieren
pol= polyfit(x,ym,2);
p3 = plot(xpl,polyval(pol,xpl),'r:');
title('Rekonstruktion der Kurve aus den Daten')

% die wichtigen handles fr die Legende zusammenstellen:
% errorbar liefert 2 handles:
%    p2(1) ... handle fr die Balken
%    p2(2) ... handle fr Datenpunkte
handle=[p1,p2(2),p3];
legend(handle,'urspr. Kurve','verrauschte Daten','Rekonstruktion',0)

% Text anzeigen
disp('beliebige Taste drcken');
%auf Tastendruck warten
pause
title('Konstante Gre der Fehler')


% ***************************************************
% subplot 2
% ***************************************************
subplot(1,2,2)

% "Testdaten erzeugen"
y  = 1+0.5*x-.07*x.^2;
ypl= 1+0.5*xpl-.07*xpl.^2;
% Ploten der "echten" Kurve
p1=plot(xpl,ypl,'b');
axis([-1 11 -2 2.5])
grid on
xlabel('x')
ylabel('f(x)')
title('Aus dieser Kurve werden Testdaten ermittelt')

% Text anzeigen
disp('beliebige Taste drcken');
%auf Tastendruck warten
pause

% "variabler Mefehler" der Gre err=.05*x erzeugen
err= 0.05*ones(size(y)).*x;
ym = y + err.*randn(size(y));
% Ploten der "Mepunkte"
hold on
p2=errorbar(x,ym,err,'ko');
title('Das sind die Testdaten (mit variablem Fehler) ')

% Text anzeigen
disp('beliebige Taste drcken');
%auf Tastendruck warten
pause

% Daraus Kurve rekonstruieren
pol= polyfit(x,ym,2);
p3 = plot(xpl,polyval(pol,xpl),'r:');
title('Variable Gre der Fehler')

% die wichtigen handles fr die Legende zusammenstellen:
% errorbar liefert 2 handles:
%    p2(1) ... handle fr die Balken
%    p2(2) ... handle fr Datenpunkte
handle=[p1,p2(2),p3];
legend(handle,'urspr. Kurve','verrauschte Daten','Rekonstruktion',0)