% script4
%
% Demo: Ausgleichsgerade durch den Ursprung
%
% Autor:           Alexander Prll
% Erstellt, am:    28.11.1999
% Modifiziert, am: 
%
% alle vorherigen Variablen lschen
clear all;

%ffnen einer figure
fig=figure;

% x-Werte
x   = 0:10;
xpl = 0:.01:10;


% "Testdaten erzeugen"
y  = 0.5*x;
ypl= 0.5*xpl;
% Ploten der "echten" Kurve
p1=plot(xpl,ypl,'b');
axis([-.5 10.5 -.5 5.5])
grid on
xlabel('x')
ylabel('f(x)')
title('Aus dieser Kurve werden Testdaten ermittelt')

% Text anzeigen
disp('beliebige Taste drcken');
%auf Tastendruck warten
pause

% "konstanten Mefehler" der Gre err=.2 erzeugen
err= 0.2*ones(size(y));
ym = y + err.*randn(size(y));
% Ploten der "Mepunkte"
hold on
p2=errorbar(x,ym,err,'ko');
title('Das sind die Testdaten (mit konst. Fehler) ')

% Text anzeigen
disp('beliebige Taste drcken');
%auf Tastendruck warten
pause

% Daraus Kurve rekonstruieren
k = sum(x.*ym)/sum(x.^2);
p3 = plot(xpl,k*xpl,'r:');
title('Rekonstruktion mit Nebenbedingung: f(0)=0')

% die wichtigen handles fr die Legende zusammenstellen:
% errorbar liefert 2 handles:
%    p2(1) ... handle fr die Balken
%    p2(2) ... handle fr Datenpunkte
handle=[p1,p2(2),p3];
legend(handle,'urspr. Kurve','verrauschte Daten','Rekonstruktion',0)
