% script9
%
% Demo: plotten von Funktionen in Polarkoordinaten
%
% Autor:           Bernhard Seiwald
% Erstellt, am:    20.11.1999
% Modifiziert, am: 
%
% Handle der Figur ermitteln
fig_handle = figure;

% Ausgabefenster lschen
clf;

% Daten laden
kerrtab  = load('kerrtab-i.dat');

% Daten in entsprechende Vektoren ablegen
% Winkel von grad in radiant umwandeln
angle    = kerrtab(:,1) * pi / 180;
linear   = kerrtab(:,2);
zirkular = kerrtab(:,3);
elliptic = kerrtab(:,4);

% max. Wert fr r suchen und aufrunden
maxval = 10*ceil( max( max( kerrtab(:,2:4) ) ) / 10);

% unschne Methode um Polarplot in entsprechender Gre zu ffnen
figure(fig_handle);
polar(0, maxval);
hold on;

% Daten zeichnen
l_handle = polar(angle, linear,   'b');
z_handle = polar(angle, zirkular, 'r');
e_handle = polar(angle, elliptic, 'g');

% handles in Vektor zusammenfassen
p_handles = [l_handle z_handle e_handle];

% Legende erstellen
legend(p_handles, 'linear polarisirt', 'zirkular polarisiert', ...
       'elliptisch polarisiert', 0)

% Text fr Titel in String speichern
text_str = sprintf('%s\n%s', 'Intensitten des durchgelassenen Lichts', ...
		   'als Funktion des Winkels \Delta \phi');

% Titel mit Funktion text() setzen
text(-320, 210, text_str)

hold off;
