% script10
%
% Demo: plotten von Funktionen mit Fehlerbalken - errorbar
%
% Autor:           Bernhard Seiwald
% Erstellt, am:    20.11.1999
% Modifiziert von Alexander Prll 
% Modifiziert am:  29.11.1999
%
% Handle der Figur ermitteln
fig_handle = figure;
% Ausgabefenster lschen
clf;

% Daten laden
kerrtab = load('kerrtab-pu.dat');

% Daten in entsprechende Vektoren ablegen
%  U^2, \Delta U^2
spannung = kerrtab(:,1);
%  \varphi, \Delta \varphi
gruen    = kerrtab(:,2:3);
gelb     = kerrtab(:,4:5);
blau     = kerrtab(:,6:7);

% max. Wert fr r suchen und aufrunden
maxval = 10*ceil( max( max( kerrtab(:,2:7) ) ) / 10);

figure(fig_handle);
% Achsen festlegen
axis([0 max(spannung) 0 maxval]);
hold on;

% Kurven zeichnen
g_handle = errorbar(spannung, gruen(:,1), gruen(:,2), 'go');
y_handle = errorbar(spannung, gelb(:,1),  gelb(:,2),  'yx');
b_handle = errorbar(spannung, blau(:,1),  blau(:,2),  'b+');

% Ausgleichsgeraden
k1  = sum(spannung.*gruen(:,1))/sum(spannung.^2);
pl1 = plot(spannung, k1*spannung, 'g');
str1= sprintf('grn: k=%3.2e',k1);
k2  = sum(spannung.*gelb(:,1))/sum(spannung.^2);
pl2 = plot(spannung, k2*spannung, 'y');
str2= sprintf('gelb: k=%3.2e',k2);
k3  = sum(spannung.*blau(:,1))/sum(spannung.^2);
pl3 = plot(spannung, k3*spannung, 'b');
str3= sprintf('blau: k=%3.2e',k3);

% handles in Vektor zusammenfassen
p_handles = [pl1 pl2 pl3];

% Legende erstellen
legend(p_handles, str1, str2, str3, 0);

% Achsen beschriften
xlabel('U^2_{kerr} / V^2');
ylabel('\Delta \phi / rad');

% Titel
text_str = sprintf('%s %s',...
		   'Direkte Messung der Phasenverschiebung \Delta \phi',...
		   'bei verschiedenen Kerrspannungen U_{kerr}');
title(text_str);

hold off;
