function str = polyout(p)
%  str = polyout(p)
% 
% INPUT:   p   ... Koeffizienten eines Polynoms (vgl. polyval)
% OUTPUT:  str ... formatierter String, der das Polynom in
%                  lesbarer Form enthaelt
% 
% Autor: A. Pruell
% Datum: 09.05.2001

if nargin ~= 1
    error('Anzahl der Argumente ungleich 1!')
end
n = size(p);
if length(n) ~= 2 | (n(1)~=1 & n(2)~=1)
    error('Argument muss ein Vektor sein!')
end    
if ~isnumeric(p)
    error('Argument muss numerisch sein!')
end


if p(1)<0
    str = '-';
else
    str = '';
end
for l = 1: length(p)-1
    str = [str,num2str(abs(p(l))),' x^',num2str(length(p)-l)];
    if p(l+1)<0
        str = [str,' - '];
    else
        str = [str,' + '];
    end
end
str = [str,num2str(abs(p(end)))];
